STOFFGraphicListener Class Reference documentation

STOFFGraphicListener Class Referencefinal

This class contains the code needed to create Graphic document. More...

`#include <STOFFGraphicListener.hxx>`

Inheritance diagram for STOFFGraphicListener:

## Public Member Functions
| STOFFGraphicListener (STOFFListManagerPtr listManager, std::vector< STOFFPageSpan > const &pageList, librevenge::RVNGDrawingInterface *drawingInterface)
| constructor with a drawing interface
| STOFFGraphicListener (STOFFListManagerPtr listManager, std::vector< STOFFPageSpan > const &pageList, librevenge::RVNGPresentationInterface *presentationInterface)
| constructor with a presentation interface
| ~STOFFGraphicListener () final
| destructor
Type | getType () const final
| returns the listener type
void | setDocumentLanguage (std::string locale) final
| sets the documents language
void | setDocumentMetaData (const librevenge::RVNGPropertyList &list) final
| sets the document meta data
void | startDocument () final
| starts a new document
void | endDocument (bool sendDelayedSubDoc=true) final
| ends the actual document
bool | canWriteText () const final
| returns true if a text zone is opened
bool | isDocumentStarted () const final
| returns true if a document is opened
void | handleSubDocument (STOFFSubDocumentPtr subDocument, libstoff::SubDocumentType subDocumentType) final
| function called to add a subdocument and modify the origin
bool | isSubDocumentOpened (libstoff::SubDocumentType &subdocType) const final
| returns try if a subdocument is open
bool | openFrame (STOFFFrameStyle const &frame, STOFFGraphicStyle const &style=STOFFGraphicStyle()) final
| store the position and the style (which will be needed further to insert a textbox or a table with openTable)
void | closeFrame () final
| close a frame
bool | openGroup (STOFFFrameStyle const &frame) final
| open a group
void | closeGroup () final
| close a group
bool | openLayer (librevenge::RVNGString const &name)
| open a layer
void | closeLayer ()
| close a layer
bool | openMasterPage (STOFFPageSpan &masterPage)
| opens a master page
void | closeMasterPage ()
| close a master page
bool | isPageSpanOpened () const final
| returns true if a page is opened
STOFFPageSpan const & | getPageSpan () final
| returns the current page span
bool | openHeader (librevenge::RVNGPropertyList const &extras) final
| open a header (interaction with STOFFPageSpan which fills the parameters for openHeader)
bool | openFooter (librevenge::RVNGPropertyList const &extras) final
| open a footer (interaction with STOFFPageSpan which fills the parameters for openFooter)
bool | closeHeader () final
| close a header
bool | closeFooter () final
| close a footer
bool | insertHeaderRegion (STOFFSubDocumentPtr subDocument, librevenge::RVNGString const &which) final
| insert a header
bool | insertFooterRegion (STOFFSubDocumentPtr subDocument, librevenge::RVNGString const &which) final
| insert a footer
bool | isHeaderFooterOpened () const final
| returns true if the header/footer is open
void | insertChar (uint8_t character) final
| adds a basic character, ..
void | insertUnicode (uint32_t character) final
| insert a character using the font converter to find the utf8 character
void | insertUnicodeString (librevenge::RVNGString const &str) final
| adds a unicode string
void | insertTab () final
| adds a tab
void | insertEOL (bool softBreak=false) final
| adds an end of line ( by default an hard one)
void | setFont (STOFFFont const &font) final
| sets the font
STOFFFont const & | getFont () const final
| returns the actual font
bool | isParagraphOpened () const final
| returns true if a paragraph or a list is opened
void | setParagraph (STOFFParagraph const &paragraph) final
| sets the paragraph
STOFFParagraph const & | getParagraph () const final
| returns the actual paragraph
void | defineStyle (STOFFFont const &style) final
| defines a font styles
bool | isFontStyleDefined (librevenge::RVNGString const &name) const final
| check if a font style with a display name is already defined
void | defineStyle (STOFFGraphicStyle const &style) final
| defines a graphic styles
bool | isGraphicStyleDefined (librevenge::RVNGString const &name) const final
| check if a graphic style with a display name is already defined
void | defineStyle (STOFFParagraph const &style) final
| defines a paragraph styles
bool | isParagraphStyleDefined (librevenge::RVNGString const &name) const final
| check if a paragraph style with a display name is already defined
void | insertField (STOFFField const &field) final
| adds a field type
void | openLink (STOFFLink const &link) final
| open a link
void | closeLink () final
| close a link
void | insertShape (STOFFFrameStyle const &frame, STOFFGraphicShape const &shape, STOFFGraphicStyle const &style) final
| adds a shape picture in given position
void | insertTextBox (STOFFFrameStyle const &frame, STOFFSubDocumentPtr subDocument, STOFFGraphicStyle const &style=STOFFGraphicStyle()) final
| adds a textbox in given position
void | insertPicture (STOFFFrameStyle const &frame, STOFFEmbeddedObject const &picture, STOFFGraphicStyle const &style=STOFFGraphicStyle()) final
| adds a picture with potential various representationin given position
void | insertEquation (STOFFFrameStyle const &frame, librevenge::RVNGString const &equation, STOFFGraphicStyle const &style=STOFFGraphicStyle()) final
| adds a equation given a position
void | insertNote (STOFFNote const &note, STOFFSubDocumentPtr &subDocument) final
| insert a note
void | insertComment (STOFFSubDocumentPtr &subDocument, librevenge::RVNGString const &creator="", librevenge::RVNGString const &date="") final
| adds comment
void | openTable (STOFFTable const &table) final
| open a table (using the last parameters of openFrame for the position )
void | openTable (STOFFFrameStyle const &frame, STOFFTable const &table)
| open a table in a given position
void | closeTable () final
| closes this table
void | openTableRow (float h, librevenge::RVNGUnit unit, bool headerRow=false) final
| open a row with given height ( if h < 0.0, set min-row-height = -h )
void | closeTableRow () final
| closes this row
void | openTableCell (STOFFCell const &cell) final
| open a cell
void | closeTableCell () final
| close a cell
void | addCoveredTableCell (STOFFVec2i const &pos) final
| add covered cell
void | addEmptyTableCell (STOFFVec2i const &pos, STOFFVec2i span=STOFFVec2i(1, 1)) final
| add empty cell
bool | canOpenSectionAddBreak () const final
| returns true if we can add open a section, add page break, ...
bool | isSectionOpened () const final
| returns true if a section is opened
STOFFSection const & | getSection () const final
| returns the actual section
bool | openSection (STOFFSection const &section) final
| open a section if possible
bool | closeSection () final
| close a section
void | insertBreak (BreakType breakType) final
| inserts a break type: ColumBreak, PageBreak, ..
Public Member Functions inherited from STOFFListener
virtual | ~STOFFListener ()
| destructor
STOFFListManagerPtr | getListManager () const
| return the list manager
void | insertUnicodeList (std::vector< uint32_t > const &list)
| try to insert a list of unicode character

## Protected Member Functions
void | _openPageSpan (bool sendHeaderFooters=true)
| does open a new page (low level)
void | _closePageSpan (bool masterPage=false)
| does close a page (low level)
void | _startSubDocument ()
void | _endSubDocument ()
void | _handleFrameParameters (librevenge::RVNGPropertyList &propList, STOFFFrameStyle const &frame, STOFFGraphicStyle const &style)
| adds in propList the frame parameters.
void | _openParagraph ()
void | _closeParagraph ()
void | _resetParagraphState (const bool isListElement=false)
void | _openListElement ()
| open a list level
void | _closeListElement ()
| close a list level
void | _changeList ()
| update the list so that it corresponds to the actual level
int | _getListId () const
| low level: find a list id which corresponds to actual list and a change of level.
void | _openSpan ()
void | _closeSpan ()
void | _flushText ()
std::shared_ptr< STOFFGraphicListenerInternal::State > | _pushParsingState ()
| creates a new parsing state (copy of the actual state)
void | _popParsingState ()
| resets the previous parsing state
Protected Member Functions inherited from STOFFListener
| STOFFListener (STOFFListManagerPtr &listManager)
| constructor

## Protected Attributes
std::shared_ptr< STOFFGraphicListenerInternal::GraphicState > | m_ds
| the actual global state
std::shared_ptr< STOFFGraphicListenerInternal::State > | m_ps
| the actual local parse state
std::vector< std::shared_ptr< STOFFGraphicListenerInternal::State > > | m_psStack
| stack of local state
librevenge::RVNGDrawingInterface * | m_drawingInterface
| the drawing interface
librevenge::RVNGPresentationInterface * | m_presentationInterface
| the presentation interface
Protected Attributes inherited from STOFFListener
STOFFListManagerPtr | m_listManager
| the list manager

## Private Member Functions
| STOFFGraphicListener (const STOFFGraphicListener &)
STOFFGraphicListener & | operator= (const STOFFGraphicListener &)

## Additional Inherited Members
Public Types inherited from STOFFListener
enum | Type { Graphic , Presentation , Spreadsheet , Text }
| the listener type More...
enum | BreakType { PageBreak =0 , SoftPageBreak , ColumnBreak }
| the different break type More...

## Detailed Description

This class contains the code needed to create Graphic document.

Note
  All units are specified in librevenge::RVNG_POINT

## Constructor & Destructor Documentation

## ◆ STOFFGraphicListener() [1/3]

STOFFGraphicListener::STOFFGraphicListener | ( | STOFFListManagerPtr | listManager,
|  | std::vector< STOFFPageSpan > const & | pageList,
|  | librevenge::RVNGDrawingInterface * | drawingInterface )

constructor with a drawing interface

Referenced by operator=(), and STOFFGraphicListener().

## ◆ STOFFGraphicListener() [2/3]

STOFFGraphicListener::STOFFGraphicListener | ( | STOFFListManagerPtr | listManager,
|  | std::vector< STOFFPageSpan > const & | pageList,
|  | librevenge::RVNGPresentationInterface * | presentationInterface )

constructor with a presentation interface

## ◆ ~STOFFGraphicListener()

STOFFGraphicListener::~STOFFGraphicListener | ( |  | ) |
| final

destructor

## ◆ STOFFGraphicListener() [3/3]

STOFFGraphicListener::STOFFGraphicListener | ( | const STOFFGraphicListener & |  | ) |
| private

## Member Function Documentation

## ◆ _changeList()

void STOFFGraphicListener::_changeList | ( |  | ) |
| protected

update the list so that it corresponds to the actual level

Referenced by _closePageSpan(), _endSubDocument(), _openSpan(), and closeTableCell().

## ◆ _closeListElement()

void STOFFGraphicListener::_closeListElement | ( |  | ) |
| protected

close a list level

Referenced by _closeParagraph().

## ◆ _closePageSpan()

void STOFFGraphicListener::_closePageSpan | ( | bool | masterPage = false | ) |
| protected

does close a page (low level)

Referenced by closeMasterPage(), endDocument(), insertBreak(), and openMasterPage().

## ◆ _closeParagraph()

void STOFFGraphicListener::_closeParagraph | ( |  | ) |
| protected

Referenced by _changeList(), _closePageSpan(), _endSubDocument(), closeTableCell(), insertEOL(), and openTable().

## ◆ _closeSpan()

void STOFFGraphicListener::_closeSpan | ( |  | ) |
| protected

Referenced by _closeListElement(), _closeParagraph(), and setFont().

## ◆ _endSubDocument()

void STOFFGraphicListener::_endSubDocument | ( |  | ) |
| protected

Referenced by _closePageSpan(), closeGroup(), closeLayer(), closeTable(), and handleSubDocument().

## ◆ _flushText()

void STOFFGraphicListener::_flushText | ( |  | ) |
| protected

Referenced by _closeSpan(), closeLink(), insertEOL(), insertField(), insertShape(), insertTab(), and openLink().

## ◆ _getListId()

int STOFFGraphicListener::_getListId | ( |  | ) | const
| protected

low level: find a list id which corresponds to actual list and a change of level.

Note
  called when the list id is not set

Referenced by _changeList().

## ◆ _handleFrameParameters()

void STOFFGraphicListener::_handleFrameParameters | ( | librevenge::RVNGPropertyList & | propList,
|  | STOFFFrameStyle const & | frame,
|  | STOFFGraphicStyle const & | style )
| protected

adds in propList the frame parameters.

Note
  if there is some gradient, first draw a rectangle to print the gradient and them update propList

Referenced by insertEquation(), insertPicture(), insertTextBox(), openFooter(), openHeader(), and openTable().

## ◆ _openListElement()

void STOFFGraphicListener::_openListElement | ( |  | ) |
| protected

open a list level

Referenced by _openSpan().

## ◆ _openPageSpan()

void STOFFGraphicListener::_openPageSpan | ( | bool | sendHeaderFooters = true | ) |
| protected

does open a new page (low level)

Referenced by endDocument(), getPageSpan(), handleSubDocument(), insertBreak(), insertEquation(), insertPicture(), insertShape(), insertTextBox(), openFrame(), openGroup(), and openLayer().

## ◆ _openParagraph()

void STOFFGraphicListener::_openParagraph | ( |  | ) |
| protected

Referenced by _openSpan(), insertComment(), insertNote(), and insertShape().

## ◆ _openSpan()

void STOFFGraphicListener::_openSpan | ( |  | ) |
| protected

Referenced by insertChar(), insertEOL(), insertField(), insertShape(), insertTab(), insertUnicode(), insertUnicodeString(), and openLink().

## ◆ _popParsingState()

void STOFFGraphicListener::_popParsingState | ( |  | ) |
| protected

resets the previous parsing state

Referenced by _closePageSpan(), closeGroup(), closeLayer(), closeLink(), closeTable(), and handleSubDocument().

## ◆ _pushParsingState()

std::shared_ptr< STOFFGraphicListenerInternal::State > STOFFGraphicListener::_pushParsingState | ( |  | ) |
| protected

creates a new parsing state (copy of the actual state)

Returns
  the old one

Referenced by handleSubDocument(), openGroup(), openLayer(), openLink(), and openTable().

## ◆ _resetParagraphState()

void STOFFGraphicListener::_resetParagraphState | ( | const bool | isListElement = false | ) |
| protected

Referenced by _openListElement(), and _openParagraph().

## ◆ _startSubDocument()

void STOFFGraphicListener::_startSubDocument | ( |  | ) |
| protected

Referenced by handleSubDocument(), openGroup(), openLayer(), and openTable().

## ◆ addCoveredTableCell()

void STOFFGraphicListener::addCoveredTableCell | ( | STOFFVec2i const & | pos | ) |
| finalvirtual

add covered cell

Implements STOFFListener.

## ◆ addEmptyTableCell()

void STOFFGraphicListener::addEmptyTableCell | ( | STOFFVec2i const & | pos,
|  | STOFFVec2i | span = STOFFVec2i(1,1) )
| finalvirtual

add empty cell

Implements STOFFListener.

## ◆ canOpenSectionAddBreak()

bool STOFFGraphicListener::canOpenSectionAddBreak | ( |  | ) | const
| inlinefinalvirtual

returns true if we can add open a section, add page break, ...

Implements STOFFListener.

Referenced by canOpenSectionAddBreak().

## ◆ canWriteText()

bool STOFFGraphicListener::canWriteText | ( |  | ) | const
| finalvirtual

returns true if a text zone is opened

Implements STOFFListener.

Referenced by insertComment(), and insertNote().

## ◆ closeFooter()

bool STOFFGraphicListener::closeFooter | ( |  | ) |
| finalvirtual

close a footer

Implements STOFFListener.

## ◆ closeFrame()

void STOFFGraphicListener::closeFrame | ( |  | ) |
| finalvirtual

close a frame

Implements STOFFListener.

Referenced by closeFooter(), closeHeader(), and insertTextBox().

## ◆ closeGroup()

void STOFFGraphicListener::closeGroup | ( |  | ) |
| finalvirtual

close a group

Implements STOFFListener.

## ◆ closeHeader()

bool STOFFGraphicListener::closeHeader | ( |  | ) |
| finalvirtual

close a header

Implements STOFFListener.

## ◆ closeLayer()

void STOFFGraphicListener::closeLayer | ( |  | ) |

close a layer

## ◆ closeLink()

void STOFFGraphicListener::closeLink | ( |  | ) |
| finalvirtual

close a link

Implements STOFFListener.

## ◆ closeMasterPage()

void STOFFGraphicListener::closeMasterPage | ( |  | ) |
| inline

close a master page

Referenced by closeMasterPage().

## ◆ closeSection()

bool STOFFGraphicListener::closeSection | ( |  | ) |
| inlinefinalvirtual

close a section

Implements STOFFListener.

Referenced by closeSection().

## ◆ closeTable()

void STOFFGraphicListener::closeTable | ( |  | ) |
| finalvirtual

closes this table

Implements STOFFListener.

Referenced by _closePageSpan(), and _endSubDocument().

## ◆ closeTableCell()

void STOFFGraphicListener::closeTableCell | ( |  | ) |
| finalvirtual

close a cell

Implements STOFFListener.

Referenced by addCoveredTableCell(), addEmptyTableCell(), and openTableCell().

## ◆ closeTableRow()

void STOFFGraphicListener::closeTableRow | ( |  | ) |
| finalvirtual

closes this row

Implements STOFFListener.

## ◆ defineStyle() [1/3]

void STOFFGraphicListener::defineStyle | ( | STOFFFont const & | style | ) |
| finalvirtual

defines a font styles

Implements STOFFListener.

## ◆ defineStyle() [2/3]

void STOFFGraphicListener::defineStyle | ( | STOFFGraphicStyle const & | style | ) |
| finalvirtual

defines a graphic styles

Implements STOFFListener.

## ◆ defineStyle() [3/3]

void STOFFGraphicListener::defineStyle | ( | STOFFParagraph const & | style | ) |
| finalvirtual

defines a paragraph styles

Implements STOFFListener.

## ◆ endDocument()

void STOFFGraphicListener::endDocument | ( | bool | sendDelayedSubDoc = true | ) |
| finalvirtual

ends the actual document

Implements STOFFListener.

## ◆ getFont()

STOFFFont const & STOFFGraphicListener::getFont | ( |  | ) | const
| finalvirtual

returns the actual font

Implements STOFFListener.

## ◆ getPageSpan()

STOFFPageSpan const & STOFFGraphicListener::getPageSpan | ( |  | ) |
| finalvirtual

returns the current page span

Note
  this forces the opening of a new page if no page is opened.

Implements STOFFListener.

## ◆ getParagraph()

STOFFParagraph const & STOFFGraphicListener::getParagraph | ( |  | ) | const
| finalvirtual

returns the actual paragraph

Implements STOFFListener.

## ◆ getSection()

STOFFSection const & STOFFGraphicListener::getSection | ( |  | ) | const
| finalvirtual

returns the actual section

Implements STOFFListener.

## ◆ getType()

Type STOFFGraphicListener::getType | ( |  | ) | const
| inlinefinalvirtual

returns the listener type

Implements STOFFListener.

## ◆ handleSubDocument()

void STOFFGraphicListener::handleSubDocument | ( | STOFFSubDocumentPtr | subDocument,
|  | libstoff::SubDocumentType | subDocumentType )
| finalvirtual

function called to add a subdocument and modify the origin

Implements STOFFListener.

Referenced by insertComment(), insertFooterRegion(), insertHeaderRegion(), insertNote(), and insertTextBox().

## ◆ insertBreak()

void STOFFGraphicListener::insertBreak | ( | BreakType | breakType | ) |
| finalvirtual

inserts a break type: ColumBreak, PageBreak, ..

Implements STOFFListener.

## ◆ insertChar()

void STOFFGraphicListener::insertChar | ( | uint8_t | character | ) |
| finalvirtual

adds a basic character, ..

Implements STOFFListener.

Referenced by insertComment(), and insertNote().

## ◆ insertComment()

void STOFFGraphicListener::insertComment | ( | STOFFSubDocumentPtr & | subDocument,
|  | librevenge::RVNGString const & | creator = "",
|  | librevenge::RVNGString const & | date = "" )
| finalvirtual

adds comment

Note
  as RVNGDrawingInterface does not accept comment, comment can only be inserted in a text zone (and are inserted between –)

Implements STOFFListener.

## ◆ insertEOL()

void STOFFGraphicListener::insertEOL | ( | bool | softBreak = false | ) |
| finalvirtual

adds an end of line ( by default an hard one)

Implements STOFFListener.

## ◆ insertEquation()

void STOFFGraphicListener::insertEquation | ( | STOFFFrameStyle const & | frame,
|  | librevenge::RVNGString const & | equation,
|  | STOFFGraphicStyle const & | style = STOFFGraphicStyle() )
| finalvirtual

adds a equation given a position

Implements STOFFListener.

## ◆ insertField()

void STOFFGraphicListener::insertField | ( | STOFFField const & | field | ) |
| finalvirtual

adds a field type

Implements STOFFListener.

## ◆ insertFooterRegion()

bool STOFFGraphicListener::insertFooterRegion | ( | STOFFSubDocumentPtr | subDocument,
|  | librevenge::RVNGString const & | which )
| finalvirtual

insert a footer

Implements STOFFListener.

## ◆ insertHeaderRegion()

bool STOFFGraphicListener::insertHeaderRegion | ( | STOFFSubDocumentPtr | subDocument,
|  | librevenge::RVNGString const & | which )
| finalvirtual

insert a header

Implements STOFFListener.

## ◆ insertNote()

void STOFFGraphicListener::insertNote | ( | STOFFNote const & | note,
|  | STOFFSubDocumentPtr & | subDocument )
| finalvirtual

insert a note

Note
  as RVNGDrawingInterface does not accept note, note can only be inserted in a text zone (and are inserted between –)

Implements STOFFListener.

## ◆ insertPicture()

void STOFFGraphicListener::insertPicture | ( | STOFFFrameStyle const & | frame,
|  | STOFFEmbeddedObject const & | picture,
|  | STOFFGraphicStyle const & | style = STOFFGraphicStyle() )
| finalvirtual

adds a picture with potential various representationin given position

Implements STOFFListener.

## ◆ insertShape()

void STOFFGraphicListener::insertShape | ( | STOFFFrameStyle const & | frame,
|  | STOFFGraphicShape const & | shape,
|  | STOFFGraphicStyle const & | style )
| finalvirtual

adds a shape picture in given position

Implements STOFFListener.

## ◆ insertTab()

void STOFFGraphicListener::insertTab | ( |  | ) |
| finalvirtual

adds a tab

Implements STOFFListener.

## ◆ insertTextBox()

void STOFFGraphicListener::insertTextBox | ( | STOFFFrameStyle const & | frame,
|  | STOFFSubDocumentPtr | subDocument,
|  | STOFFGraphicStyle const & | style = STOFFGraphicStyle() )
| finalvirtual

adds a textbox in given position

Implements STOFFListener.

## ◆ insertUnicode()

void STOFFGraphicListener::insertUnicode | ( | uint32_t | character | ) |
| finalvirtual

insert a character using the font converter to find the utf8 character

adds an unicode character. By convention if character=0xfffd(undef), no character is added

Implements STOFFListener.

Referenced by insertChar(), insertComment(), and insertNote().

## ◆ insertUnicodeString()

void STOFFGraphicListener::insertUnicodeString | ( | librevenge::RVNGString const & | str | ) |
| finalvirtual

adds a unicode string

Implements STOFFListener.

## ◆ isDocumentStarted()

bool STOFFGraphicListener::isDocumentStarted | ( |  | ) | const
| finalvirtual

returns true if a document is opened

Implements STOFFListener.

## ◆ isFontStyleDefined()

bool STOFFGraphicListener::isFontStyleDefined | ( | librevenge::RVNGString const & | name | ) | const
| finalvirtual

check if a font style with a display name is already defined

Implements STOFFListener.

## ◆ isGraphicStyleDefined()

bool STOFFGraphicListener::isGraphicStyleDefined | ( | librevenge::RVNGString const & | name | ) | const
| finalvirtual

check if a graphic style with a display name is already defined

Implements STOFFListener.

## ◆ isHeaderFooterOpened()

bool STOFFGraphicListener::isHeaderFooterOpened | ( |  | ) | const
| finalvirtual

returns true if the header/footer is open

Implements STOFFListener.

## ◆ isPageSpanOpened()

bool STOFFGraphicListener::isPageSpanOpened | ( |  | ) | const
| finalvirtual

returns true if a page is opened

Implements STOFFListener.

## ◆ isParagraphOpened()

bool STOFFGraphicListener::isParagraphOpened | ( |  | ) | const
| finalvirtual

returns true if a paragraph or a list is opened

Implements STOFFListener.

## ◆ isParagraphStyleDefined()

bool STOFFGraphicListener::isParagraphStyleDefined | ( | librevenge::RVNGString const & | name | ) | const
| finalvirtual

check if a paragraph style with a display name is already defined

Implements STOFFListener.

## ◆ isSectionOpened()

bool STOFFGraphicListener::isSectionOpened | ( |  | ) | const
| inlinefinalvirtual

returns true if a section is opened

Implements STOFFListener.

## ◆ isSubDocumentOpened()

bool STOFFGraphicListener::isSubDocumentOpened | ( | libstoff::SubDocumentType & | subdocType | ) | const
| finalvirtual

returns try if a subdocument is open

Implements STOFFListener.

## ◆ openFooter()

bool STOFFGraphicListener::openFooter | ( | librevenge::RVNGPropertyList const & | extras | ) |
| finalvirtual

open a footer (interaction with STOFFPageSpan which fills the parameters for openFooter)

Implements STOFFListener.

## ◆ openFrame()

bool STOFFGraphicListener::openFrame | ( | STOFFFrameStyle const & | frame,
|  | STOFFGraphicStyle const & | style = STOFFGraphicStyle() )
| finalvirtual

store the position and the style (which will be needed further to insert a textbox or a table with openTable)

Implements STOFFListener.

Referenced by insertTextBox(), openFooter(), and openHeader().

## ◆ openGroup()

bool STOFFGraphicListener::openGroup | ( | STOFFFrameStyle const & | frame | ) |
| finalvirtual

open a group

Implements STOFFListener.

## ◆ openHeader()

bool STOFFGraphicListener::openHeader | ( | librevenge::RVNGPropertyList const & | extras | ) |
| finalvirtual

open a header (interaction with STOFFPageSpan which fills the parameters for openHeader)

Implements STOFFListener.

## ◆ openLayer()

bool STOFFGraphicListener::openLayer | ( | librevenge::RVNGString const & | name | ) |

open a layer

## ◆ openLink()

void STOFFGraphicListener::openLink | ( | STOFFLink const & | link | ) |
| finalvirtual

open a link

Implements STOFFListener.

## ◆ openMasterPage()

bool STOFFGraphicListener::openMasterPage | ( | STOFFPageSpan & | masterPage | ) |

opens a master page

## ◆ openSection()

bool STOFFGraphicListener::openSection | ( | STOFFSection const & | section | ) |
| finalvirtual

open a section if possible

Implements STOFFListener.

## ◆ openTable() [1/2]

void STOFFGraphicListener::openTable | ( | STOFFFrameStyle const & | frame,
|  | STOFFTable const & | table )

open a table in a given position

## ◆ openTable() [2/2]

void STOFFGraphicListener::openTable | ( | STOFFTable const & | table | ) |
| finalvirtual

open a table (using the last parameters of openFrame for the position )

Implements STOFFListener.

Referenced by openTable().

## ◆ openTableCell()

void STOFFGraphicListener::openTableCell | ( | STOFFCell const & | cell | ) |
| finalvirtual

open a cell

Implements STOFFListener.

## ◆ openTableRow()

void STOFFGraphicListener::openTableRow | ( | float | h,
|  | librevenge::RVNGUnit | unit,
|  | bool | headerRow = false )
| finalvirtual

open a row with given height ( if h < 0.0, set min-row-height = -h )

Implements STOFFListener.

## ◆ operator=()

STOFFGraphicListener & STOFFGraphicListener::operator= | ( | const STOFFGraphicListener & |  | ) |
| private

## ◆ setDocumentLanguage()

void STOFFGraphicListener::setDocumentLanguage | ( | std::string | locale | ) |
| finalvirtual

sets the documents language

Implements STOFFListener.

## ◆ setDocumentMetaData()

void STOFFGraphicListener::setDocumentMetaData | ( | const librevenge::RVNGPropertyList & | list | ) |
| finalvirtual

sets the document meta data

Implements STOFFListener.

## ◆ setFont()

void STOFFGraphicListener::setFont | ( | STOFFFont const & | font | ) |
| finalvirtual

sets the font

Implements STOFFListener.

## ◆ setParagraph()

void STOFFGraphicListener::setParagraph | ( | STOFFParagraph const & | paragraph | ) |
| finalvirtual

sets the paragraph

Implements STOFFListener.

## ◆ startDocument()

void STOFFGraphicListener::startDocument | ( |  | ) |
| finalvirtual

starts a new document

Implements STOFFListener.

Referenced by _openPageSpan(), and openMasterPage().

## Member Data Documentation

## ◆ m_drawingInterface

librevenge::RVNGDrawingInterface* STOFFGraphicListener::m_drawingInterface
| protected

the drawing interface

Referenced by _changeList(), _closeListElement(), _closePageSpan(), _closeParagraph(), _closeSpan(), _flushText(), _openListElement(), _openPageSpan(), _openParagraph(), _openSpan(), addCoveredTableCell(), addEmptyTableCell(), closeFooter(), closeGroup(), closeHeader(), closeLayer(), closeLink(), closeTable(), closeTableCell(), closeTableRow(), defineStyle(), defineStyle(), defineStyle(), endDocument(), insertEOL(), insertEquation(), insertField(), insertPicture(), insertShape(), insertTab(), insertTextBox(), openFooter(), openGroup(), openHeader(), openLayer(), openLink(), openMasterPage(), openTable(), openTableCell(), openTableRow(), startDocument(), STOFFGraphicListener(), and STOFFGraphicListener().

## ◆ m_ds

std::shared_ptr<STOFFGraphicListenerInternal::GraphicState> STOFFGraphicListener::m_ds
| protected

the actual global state

Referenced by _changeList(), _closePageSpan(), _endSubDocument(), _handleFrameParameters(), _openPageSpan(), _startSubDocument(), canWriteText(), closeFooter(), closeHeader(), defineStyle(), defineStyle(), defineStyle(), endDocument(), getPageSpan(), getSection(), handleSubDocument(), insertBreak(), insertEquation(), insertFooterRegion(), insertHeaderRegion(), insertPicture(), insertShape(), insertTextBox(), isDocumentStarted(), isFontStyleDefined(), isGraphicStyleDefined(), isHeaderFooterOpened(), isPageSpanOpened(), isParagraphStyleDefined(), isSubDocumentOpened(), openFooter(), openFrame(), openGroup(), openHeader(), openLayer(), openMasterPage(), setDocumentLanguage(), setDocumentMetaData(), startDocument(), STOFFGraphicListener(), and STOFFGraphicListener().

## ◆ m_presentationInterface

librevenge::RVNGPresentationInterface* STOFFGraphicListener::m_presentationInterface
| protected

the presentation interface

Referenced by _changeList(), _closeListElement(), _closePageSpan(), _closeParagraph(), _closeSpan(), _flushText(), _openListElement(), _openPageSpan(), _openParagraph(), _openSpan(), addCoveredTableCell(), addEmptyTableCell(), closeFooter(), closeGroup(), closeHeader(), closeLayer(), closeLink(), closeTable(), closeTableCell(), closeTableRow(), defineStyle(), defineStyle(), defineStyle(), endDocument(), insertEOL(), insertEquation(), insertField(), insertPicture(), insertShape(), insertTab(), insertTextBox(), openFooter(), openGroup(), openHeader(), openLayer(), openLink(), openMasterPage(), openTable(), openTableCell(), openTableRow(), startDocument(), STOFFGraphicListener(), and STOFFGraphicListener().

## ◆ m_ps

std::shared_ptr<STOFFGraphicListenerInternal::State> STOFFGraphicListener::m_ps
| protected

the actual local parse state

Referenced by _changeList(), _closeListElement(), _closePageSpan(), _closeParagraph(), _closeSpan(), _endSubDocument(), _flushText(), _getListId(), _openListElement(), _openPageSpan(), _openParagraph(), _openSpan(), _popParsingState(), _pushParsingState(), _resetParagraphState(), _startSubDocument(), addCoveredTableCell(), addEmptyTableCell(), canWriteText(), closeFrame(), closeGroup(), closeLayer(), closeLink(), closeTable(), closeTableCell(), closeTableRow(), getFont(), getParagraph(), handleSubDocument(), insertBreak(), insertChar(), insertComment(), insertEOL(), insertEquation(), insertField(), insertNote(), insertPicture(), insertShape(), insertTab(), insertTextBox(), insertUnicode(), insertUnicodeString(), isParagraphOpened(), isSubDocumentOpened(), openFrame(), openGroup(), openLayer(), openLink(), openTable(), openTable(), openTableCell(), openTableRow(), setFont(), setParagraph(), STOFFGraphicListener(), and STOFFGraphicListener().

## ◆ m_psStack

std::vector<std::shared_ptr<STOFFGraphicListenerInternal::State> > STOFFGraphicListener::m_psStack
| protected

stack of local state

Referenced by _popParsingState(), _pushParsingState(), STOFFGraphicListener(), and STOFFGraphicListener().

The documentation for this class was generated from the following files:

- STOFFGraphicListener.hxx
- STOFFGraphicListener.cxx